import { NodeType as RRNodeType } from '@highlight-run/rrweb-snapshot';
import type { NWSAPI } from 'nwsapi';
import { BaseRRNode, ClassList, IRRDocument, CSSStyleDeclaration } from '@highlight-run/rrdom';
export declare class RRNode extends BaseRRNode {
}
export declare class RRWindow {
    scrollLeft: number;
    scrollTop: number;
    scrollTo(options?: ScrollToOptions): void;
}
declare const RRDocument_base: (new (...args: any[]) => {
    readonly nodeType: number;
    readonly nodeName: "#document";
    readonly compatMode: "BackCompat" | "CSS1Compat";
    readonly RRNodeType: RRNodeType.Document;
    textContent: string | null;
    readonly documentElement: import("@highlight-run/rrdom").IRRElement | null;
    readonly body: import("@highlight-run/rrdom").IRRElement | null;
    readonly head: import("@highlight-run/rrdom").IRRElement | null;
    readonly implementation: IRRDocument;
    readonly firstElementChild: import("@highlight-run/rrdom").IRRElement | null;
    appendChild(childNode: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    open(): void;
    close(): void;
    write(content: string): void;
    createDocument(_namespace: string | null, _qualifiedName: string | null, _doctype?: DocumentType | null | undefined): IRRDocument;
    createDocumentType(qualifiedName: string, publicId: string, systemId: string): import("@highlight-run/rrdom").IRRDocumentType;
    createElement(tagName: string): import("@highlight-run/rrdom").IRRElement;
    createElementNS(_namespaceURI: string, qualifiedName: string): import("@highlight-run/rrdom").IRRElement;
    createTextNode(data: string): import("@highlight-run/rrdom").IRRText;
    createComment(data: string): import("@highlight-run/rrdom").IRRComment;
    createCDATASection(data: string): import("@highlight-run/rrdom").IRRCDATASection;
    toString(): string;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
}) & typeof RRNode;
export declare class RRDocument extends RRDocument_base implements IRRDocument {
    readonly nodeName: '#document';
    private _nwsapi;
    get nwsapi(): NWSAPI;
    get documentElement(): RRElement | null;
    get body(): RRElement | null;
    get head(): RRElement | null;
    get implementation(): RRDocument;
    get firstElementChild(): RRElement | null;
    appendChild(childNode: RRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: RRNode, refChild: RRNode | null): import("@highlight-run/rrdom").IRRNode;
    querySelectorAll(selectors: string): RRNode[];
    getElementsByTagName(tagName: string): RRElement[];
    getElementsByClassName(className: string): RRElement[];
    getElementById(elementId: string): RRElement | null;
    createDocument(_namespace: string | null, _qualifiedName: string | null, _doctype?: DocumentType | null): RRDocument;
    createDocumentType(qualifiedName: string, publicId: string, systemId: string): RRDocumentType;
    createElement<K extends keyof HTMLElementTagNameMap>(tagName: K): RRElementType<K>;
    createElement(tagName: string): RRElement;
    createElementNS(_namespaceURI: string, qualifiedName: string): RRElement | RRMediaElement | RRCanvasElement | RRIFrameElement | RRImageElement | RRStyleElement;
    createComment(data: string): RRComment;
    createCDATASection(data: string): RRCDATASection;
    createTextNode(data: string): RRText;
}
declare const RRDocumentType_base: (new (qualifiedName: string, publicId: string, systemId: string) => {
    readonly nodeType: number;
    readonly RRNodeType: RRNodeType.DocumentType;
    readonly nodeName: string;
    readonly name: string;
    readonly publicId: string;
    readonly systemId: string;
    textContent: string | null;
    toString(): string;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
    appendChild(newChild: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
}) & typeof RRNode;
export declare class RRDocumentType extends RRDocumentType_base {
}
declare const RRElement_base: (new (tagName: string) => {
    readonly nodeType: number;
    readonly RRNodeType: RRNodeType.Element;
    readonly nodeName: string;
    tagName: string;
    attributes: Record<string, string>;
    shadowRoot: import("@highlight-run/rrdom").IRRElement | null;
    scrollLeft?: number | undefined;
    scrollTop?: number | undefined;
    textContent: string;
    readonly classList: ClassList;
    readonly id: string;
    readonly className: string;
    readonly style: CSSStyleDeclaration;
    getAttribute(name: string): string | null;
    setAttribute(name: string, attribute: string): void;
    setAttributeNS(_namespace: string | null, qualifiedName: string, value: string): void;
    removeAttribute(name: string): void;
    appendChild(newChild: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    attachShadow(_init: ShadowRootInit): import("@highlight-run/rrdom").IRRElement;
    dispatchEvent(_event: Event): boolean;
    toString(): string;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
}) & typeof RRNode;
export declare class RRElement extends RRElement_base {
    private _style;
    constructor(tagName: string);
    get style(): CSSStyleDeclaration;
    attachShadow(_init: ShadowRootInit): RRElement;
    appendChild(newChild: RRNode): RRNode;
    insertBefore(newChild: RRNode, refChild: RRNode | null): RRNode;
    getAttribute(name: string): string | null;
    setAttribute(name: string, attribute: string): void;
    removeAttribute(name: string): void;
    get firstElementChild(): RRElement | null;
    get nextElementSibling(): RRElement | null;
    querySelectorAll(selectors: string): RRNode[];
    getElementById(elementId: string): RRElement | null;
    getElementsByClassName(className: string): RRElement[];
    getElementsByTagName(tagName: string): RRElement[];
}
export declare class RRImageElement extends RRElement {
    src: string;
    width: number;
    height: number;
    onload: ((this: GlobalEventHandlers, ev: Event) => any) | null;
}
declare const RRMediaElement_base: (new (...args: any[]) => {
    currentTime?: number | undefined;
    volume?: number | undefined;
    paused?: boolean | undefined;
    muted?: boolean | undefined;
    attachShadow(_init: ShadowRootInit): import("@highlight-run/rrdom").IRRElement;
    play(): void;
    pause(): void;
    tagName: string;
    attributes: Record<string, string>;
    shadowRoot: import("@highlight-run/rrdom").IRRElement | null;
    scrollLeft?: number | undefined;
    scrollTop?: number | undefined;
    id: string;
    className: string;
    classList: ClassList;
    style: CSSStyleDeclaration;
    getAttribute(name: string): string | null;
    setAttribute(name: string, attribute: string): void;
    setAttributeNS(namespace: string | null, qualifiedName: string, value: string): void;
    removeAttribute(name: string): void;
    dispatchEvent(event: Event): boolean;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    readonly nodeType: number;
    readonly nodeName: string;
    readonly RRNodeType: RRNodeType;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    textContent: string | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
    appendChild(newChild: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    toString(): string;
}) & typeof RRElement;
export declare class RRMediaElement extends RRMediaElement_base {
}
export declare class RRCanvasElement extends RRElement {
    getContext(): CanvasRenderingContext2D | null;
}
export declare class RRStyleElement extends RRElement {
    private _sheet;
    get sheet(): CSSStyleSheet | null;
}
export declare class RRIFrameElement extends RRElement {
    width: string;
    height: string;
    src: string;
    contentDocument: RRDocument;
    contentWindow: RRWindow;
    constructor(tagName: string);
}
declare const RRText_base: (new (data: string) => {
    readonly nodeType: number;
    readonly nodeName: "#text";
    readonly RRNodeType: RRNodeType.Text;
    data: string;
    textContent: string;
    toString(): string;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
    appendChild(newChild: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
}) & typeof RRNode;
export declare class RRText extends RRText_base {
    readonly nodeName: '#text';
}
declare const RRComment_base: (new (data: string) => {
    readonly nodeType: number;
    readonly nodeName: "#comment";
    readonly RRNodeType: RRNodeType.Comment;
    data: string;
    textContent: string;
    toString(): string;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
    appendChild(newChild: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
}) & typeof RRNode;
export declare class RRComment extends RRComment_base {
    readonly nodeName: '#comment';
}
declare const RRCDATASection_base: (new (data: string) => {
    readonly nodeName: "#cdata-section";
    readonly nodeType: number;
    readonly RRNodeType: RRNodeType.CDATA;
    data: string;
    textContent: string;
    toString(): string;
    parentElement: import("@highlight-run/rrdom").IRRNode | null;
    parentNode: import("@highlight-run/rrdom").IRRNode | null;
    childNodes: import("@highlight-run/rrdom").IRRNode[];
    ownerDocument: IRRDocument;
    readonly ELEMENT_NODE: number;
    readonly TEXT_NODE: number;
    firstChild: import("@highlight-run/rrdom").IRRNode | null;
    lastChild: import("@highlight-run/rrdom").IRRNode | null;
    nextSibling: import("@highlight-run/rrdom").IRRNode | null;
    contains(node: import("@highlight-run/rrdom").IRRNode): boolean;
    appendChild(newChild: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
    insertBefore(newChild: import("@highlight-run/rrdom").IRRNode, refChild: import("@highlight-run/rrdom").IRRNode | null): import("@highlight-run/rrdom").IRRNode;
    removeChild(node: import("@highlight-run/rrdom").IRRNode): import("@highlight-run/rrdom").IRRNode;
}) & typeof RRNode;
export declare class RRCDATASection extends RRCDATASection_base {
    readonly nodeName: '#cdata-section';
}
interface RRElementTagNameMap {
    audio: RRMediaElement;
    canvas: RRCanvasElement;
    iframe: RRIFrameElement;
    img: RRImageElement;
    style: RRStyleElement;
    video: RRMediaElement;
}
declare type RRElementType<K extends keyof HTMLElementTagNameMap> = K extends keyof RRElementTagNameMap ? RRElementTagNameMap[K] : RRElement;
export {};
